#include "mawk.h"
#include "num.h"

mawk_num_id_t mawk_num_id = MAWK_NUM_ID_DOUBLE;

/* convert a number to Int (this is not as simple as a
   mawk_cast because the results are undefined if it won't fit).
   Truncate large values to +Max_Int or -Max_Int
   Send nans to -Max_Int
*/

Int mawk_d_to_I(mawk_num_t d)
{
	if (d >= Max_Int)
		return Max_Int;
	if (d > -Max_Int)
		return (Int) d;
	return -Max_Int;
}

const char *mawk_num_print_spec(mawk_num_t d)
{
	return NULL;
}
