
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         Mawk_parse
#define yylex           Mawk_lex
#define yyerror         Mawk_error
#define yylval          Mawk_lval
#define yychar          Mawk_char
#define yydebug         Mawk_debug
#define yynerrs         Mawk_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 86 "parse.y"

#include <stdio.h>
#include "mawk.h"
#include "symtype.h"
#include "code.h"
#include "memory.h"
#include "bi_funct.h"
#include "bi_vars.h"
#include "jmp.h"
#include "field.h"
#include "files.h"
#include "scan.h"


#define  YYMAXDEPTH	200

void mawk_eat_nl(mawk_state_t * MAWK, YYSTYPE *lvalp);
static void  resize_fblock(mawk_state_t *, FBLOCK *);
static void  switch_code_to_main(mawk_state_t *);
static void  mawk_code_array(mawk_state_t *, SYMTAB *);
static void  mawk_code_call_id(mawk_state_t *, CA_REC *, SYMTAB *);
static void  field_A2I(mawk_state_t *MAWK);
static void  check_var(mawk_state_t *, SYMTAB *);
static void  check_array(mawk_state_t *, SYMTAB *);
static void  RE_as_arg(mawk_state_t *MAWK);

void mawk_parser_include(mawk_state_t *MAWK, void *str);

#define  mawk_code_address(x)  if( is_local(x) ) \
			     mawk_code2op(MAWK, L_PUSHA, (x)->offset) ;\
                          else  code2(MAWK, _PUSHA, (x)->stval.cp) 

#define  CDP(x)  (mawk_code_base+(x))
/* WARNING: These CDP() calculations become invalid after calls
   that might change code_base.  Which are:  code2(), mawk_code2op(),
   code_jmp() and code_pop().
*/

/* this nonsense caters to MSDOS large model */
#define  CODE_FE_PUSHA()  mawk_code_ptr->ptr = (PTR) 0 ; code1(FE_PUSHA)



/* Line 189 of yacc.c  */
#line 125 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     UNEXPECTED = 258,
     BAD_DECIMAL = 259,
     NL = 260,
     SEMI_COLON = 261,
     LBRACE = 262,
     RBRACE = 263,
     LBOX = 264,
     RBOX = 265,
     COMMA = 266,
     IO_OUT = 267,
     POW_ASG = 268,
     MOD_ASG = 269,
     DIV_ASG = 270,
     MUL_ASG = 271,
     SUB_ASG = 272,
     ADD_ASG = 273,
     ASSIGN = 274,
     COLON = 275,
     QMARK = 276,
     OR = 277,
     AND = 278,
     IN = 279,
     MATCH = 280,
     GTE = 281,
     GT = 282,
     LTE = 283,
     LT = 284,
     NEQ = 285,
     EQ = 286,
     CAT = 287,
     GETLINE = 288,
     MINUS = 289,
     PLUS = 290,
     MOD = 291,
     DIV = 292,
     MUL = 293,
     UMINUS = 294,
     NOT = 295,
     PIPE = 296,
     IO_IN = 297,
     POW = 298,
     INC_or_DEC = 299,
     FIELD = 300,
     DOLLAR = 301,
     RPAREN = 302,
     LPAREN = 303,
     DOUBLE = 304,
     STRING_ = 305,
     RE = 306,
     ID = 307,
     D_ID = 308,
     FUNCT_ID = 309,
     C_FUNCT_ID = 310,
     BUILTIN = 311,
     LENGTH = 312,
     PRINT = 313,
     PRINTF = 314,
     SPLIT = 315,
     MATCH_FUNC = 316,
     SUB = 317,
     GSUB = 318,
     DO = 319,
     WHILE = 320,
     FOR = 321,
     BREAK = 322,
     CONTINUE = 323,
     IF = 324,
     ELSE = 325,
     DELETE = 326,
     BEGIN = 327,
     END = 328,
     EXIT = 329,
     NEXT = 330,
     RETURN = 331,
     FUNCTION = 332,
     INCLUDE = 333
   };
#endif
/* Tokens.  */
#define UNEXPECTED 258
#define BAD_DECIMAL 259
#define NL 260
#define SEMI_COLON 261
#define LBRACE 262
#define RBRACE 263
#define LBOX 264
#define RBOX 265
#define COMMA 266
#define IO_OUT 267
#define POW_ASG 268
#define MOD_ASG 269
#define DIV_ASG 270
#define MUL_ASG 271
#define SUB_ASG 272
#define ADD_ASG 273
#define ASSIGN 274
#define COLON 275
#define QMARK 276
#define OR 277
#define AND 278
#define IN 279
#define MATCH 280
#define GTE 281
#define GT 282
#define LTE 283
#define LT 284
#define NEQ 285
#define EQ 286
#define CAT 287
#define GETLINE 288
#define MINUS 289
#define PLUS 290
#define MOD 291
#define DIV 292
#define MUL 293
#define UMINUS 294
#define NOT 295
#define PIPE 296
#define IO_IN 297
#define POW 298
#define INC_or_DEC 299
#define FIELD 300
#define DOLLAR 301
#define RPAREN 302
#define LPAREN 303
#define DOUBLE 304
#define STRING_ 305
#define RE 306
#define ID 307
#define D_ID 308
#define FUNCT_ID 309
#define C_FUNCT_ID 310
#define BUILTIN 311
#define LENGTH 312
#define PRINT 313
#define PRINTF 314
#define SPLIT 315
#define MATCH_FUNC 316
#define SUB 317
#define GSUB 318
#define DO 319
#define WHILE 320
#define FOR 321
#define BREAK 322
#define CONTINUE 323
#define IF 324
#define ELSE 325
#define DELETE 326
#define BEGIN 327
#define END 328
#define EXIT 329
#define NEXT 330
#define RETURN 331
#define FUNCTION 332
#define INCLUDE 333




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 129 "parse.y"

CELL *cp ;
SYMTAB *stp ;
int  start ; /* code starting address as offset from code_base */
PF_CP  fp ;  /* ptr to a (print/printf) or (sub/gsub) function */
const BI_REC *bip ; /* ptr to info about a builtin */
FBLOCK  *fbp  ; /* ptr to a function block */
ARG2_REC *arg2p ;
CA_REC   *ca_p  ;
int   ival ;
PTR   ptr ;



/* Line 214 of yacc.c  */
#line 332 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 344 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  100
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1158

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  79
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  58
/* YYNRULES -- Number of rules.  */
#define YYNRULES  175
/* YYNRULES -- Number of states.  */
#define YYNSTATES  338

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   333

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    10,    12,    15,    17,    19,
      20,    24,    25,    29,    30,    34,    35,    36,    43,    47,
      51,    53,    55,    57,    60,    62,    65,    67,    70,    73,
      76,    78,    81,    83,    85,    87,    91,    95,    99,   103,
     107,   111,   115,   119,   123,   127,   131,   135,   139,   143,
     144,   149,   150,   155,   156,   157,   165,   167,   170,   172,
     174,   176,   180,   182,   186,   190,   194,   198,   202,   206,
     209,   212,   215,   217,   220,   223,   226,   229,   231,   232,
     234,   236,   240,   246,   248,   249,   255,   257,   259,   261,
     265,   268,   272,   276,   277,   280,   285,   288,   290,   295,
     297,   305,   310,   313,   318,   322,   327,   329,   332,   334,
     337,   341,   347,   353,   359,   366,   374,   378,   385,   388,
     390,   393,   400,   403,   407,   409,   413,   417,   421,   425,
     429,   433,   437,   440,   446,   448,   452,   459,   461,   464,
     468,   471,   475,   477,   480,   483,   487,   492,   494,   496,
     498,   501,   505,   512,   514,   516,   518,   522,   525,   530,
     533,   536,   537,   539,   541,   545,   547,   551,   555,   558,
     561,   563,   567,   571,   574,   577
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      80,     0,    -1,    81,    -1,    80,    81,    -1,    82,    -1,
     127,    -1,   132,    88,    -1,    88,    -1,   136,    -1,    -1,
      72,    83,    88,    -1,    -1,    73,    84,    88,    -1,    -1,
      93,    85,    89,    -1,    -1,    -1,    93,    11,    86,    93,
      87,    89,    -1,     7,    90,     8,    -1,     7,     1,     8,
      -1,    88,    -1,    92,    -1,    91,    -1,    90,    91,    -1,
      88,    -1,    93,    92,    -1,    92,    -1,     1,    92,    -1,
      67,    92,    -1,    68,    92,    -1,   121,    -1,    75,    92,
      -1,     5,    -1,     6,    -1,    98,    -1,   100,    19,    93,
      -1,   100,    18,    93,    -1,   100,    17,    93,    -1,   100,
      16,    93,    -1,   100,    15,    93,    -1,   100,    14,    93,
      -1,   100,    13,    93,    -1,    93,    31,    93,    -1,    93,
      30,    93,    -1,    93,    29,    93,    -1,    93,    28,    93,
      -1,    93,    27,    93,    -1,    93,    26,    93,    -1,    93,
      25,    93,    -1,    -1,    93,    22,    94,    93,    -1,    -1,
      93,    23,    95,    93,    -1,    -1,    -1,    93,    21,    96,
      93,    20,    97,    93,    -1,    99,    -1,    98,    99,    -1,
      49,    -1,    50,    -1,    52,    -1,    48,    93,    47,    -1,
      51,    -1,    99,    35,    99,    -1,    99,    34,    99,    -1,
      99,    38,    99,    -1,    99,    37,    99,    -1,    99,    36,
      99,    -1,    99,    43,    99,    -1,    40,    99,    -1,    35,
      99,    -1,    34,    99,    -1,   103,    -1,    52,    44,    -1,
      44,   100,    -1,   117,    44,    -1,    44,   117,    -1,    52,
      -1,    -1,   102,    -1,    93,    -1,   102,    11,    93,    -1,
      56,   104,    48,   101,    47,    -1,    57,    -1,    -1,   105,
     104,   106,   108,    92,    -1,    58,    -1,    59,    -1,   101,
      -1,    48,   107,    47,    -1,    48,    47,    -1,    93,    11,
      93,    -1,   107,    11,    93,    -1,    -1,    12,    93,    -1,
      69,    48,    93,    47,    -1,   109,    91,    -1,    70,    -1,
     109,    91,   110,    91,    -1,    64,    -1,   111,    91,    65,
      48,    93,    47,    92,    -1,    65,    48,    93,    47,    -1,
     112,    91,    -1,   113,   114,   115,    91,    -1,    66,    48,
       6,    -1,    66,    48,    93,     6,    -1,     6,    -1,    93,
       6,    -1,    47,    -1,    93,    47,    -1,    93,    24,    52,
      -1,    48,   107,    47,    24,    52,    -1,    52,   104,     9,
     102,    10,    -1,    52,   104,     9,   102,    10,    -1,    52,
     104,     9,   102,    10,    44,    -1,    71,    52,   104,     9,
     102,    10,    92,    -1,    71,    52,    92,    -1,    66,    48,
      52,    24,    52,    47,    -1,   116,    91,    -1,    45,    -1,
      46,    53,    -1,    46,    53,   104,     9,   102,    10,    -1,
      46,    99,    -1,    48,   117,    47,    -1,   117,    -1,   117,
      19,    93,    -1,   117,    18,    93,    -1,   117,    17,    93,
      -1,   117,    16,    93,    -1,   117,    15,    93,    -1,   117,
      14,    93,    -1,   117,    13,    93,    -1,   118,   119,    -1,
      60,    48,    93,    11,    52,    -1,    47,    -1,    11,    93,
      47,    -1,    61,    48,    93,    11,   120,    47,    -1,    93,
      -1,    74,    92,    -1,    74,    93,    92,    -1,    76,    92,
      -1,    76,    93,    92,    -1,   122,    -1,   122,   123,    -1,
     124,    99,    -1,    99,    41,    33,    -1,    99,    41,    33,
     123,    -1,    33,    -1,   100,    -1,   117,    -1,   122,    42,
      -1,   122,   123,    42,    -1,   125,    48,   120,    11,    93,
     126,    -1,    62,    -1,    63,    -1,    47,    -1,    11,   123,
      47,    -1,   128,    88,    -1,   129,    48,   130,    47,    -1,
      77,    52,    -1,    77,    54,    -1,    -1,   131,    -1,    52,
      -1,   131,    11,    52,    -1,     1,    -1,    54,   104,   133,
      -1,    55,   104,   133,    -1,    48,    47,    -1,   134,   135,
      -1,    48,    -1,   134,    93,    11,    -1,   134,    52,    11,
      -1,    93,    47,    -1,    52,    47,    -1,    78,    50,     5,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   206,   206,   207,   210,   211,   212,   215,   220,   223,
     222,   229,   228,   235,   234,   242,   258,   241,   271,   273,
     279,   280,   286,   287,   291,   292,   294,   296,   302,   305,
     308,   312,   320,   320,   323,   324,   325,   326,   327,   328,
     329,   330,   331,   332,   333,   334,   335,   336,   338,   366,
     365,   373,   372,   379,   380,   379,   385,   386,   390,   392,
     394,   402,   406,   410,   411,   412,   413,   414,   415,   416,
     418,   420,   422,   425,   433,   440,   444,   451,   460,   461,
     464,   466,   471,   482,   492,   495,   504,   505,   508,   509,
     513,   517,   522,   526,   527,   534,   539,   543,   547,   555,
     560,   566,   586,   612,   636,   637,   641,   642,   659,   663,
     676,   681,   692,   705,   717,   734,   742,   753,   767,   784,
     786,   795,   809,   811,   815,   819,   820,   821,   822,   823,
     824,   825,   831,   835,   842,   844,   868,   875,   898,   901,
     904,   907,   912,   919,   925,   930,   935,   942,   944,   944,
     946,   950,   958,   977,   978,   982,   987,   995,  1003,  1022,
    1045,  1052,  1053,  1056,  1062,  1075,  1087,  1099,  1108,  1110,
    1125,  1127,  1134,  1143,  1149,  1157
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "UNEXPECTED", "BAD_DECIMAL", "NL",
  "SEMI_COLON", "LBRACE", "RBRACE", "LBOX", "RBOX", "COMMA", "IO_OUT",
  "POW_ASG", "MOD_ASG", "DIV_ASG", "MUL_ASG", "SUB_ASG", "ADD_ASG",
  "ASSIGN", "COLON", "QMARK", "OR", "AND", "IN", "MATCH", "GTE", "GT",
  "LTE", "LT", "NEQ", "EQ", "CAT", "GETLINE", "MINUS", "PLUS", "MOD",
  "DIV", "MUL", "UMINUS", "NOT", "PIPE", "IO_IN", "POW", "INC_or_DEC",
  "FIELD", "DOLLAR", "RPAREN", "LPAREN", "DOUBLE", "STRING_", "RE", "ID",
  "D_ID", "FUNCT_ID", "C_FUNCT_ID", "BUILTIN", "LENGTH", "PRINT", "PRINTF",
  "SPLIT", "MATCH_FUNC", "SUB", "GSUB", "DO", "WHILE", "FOR", "BREAK",
  "CONTINUE", "IF", "ELSE", "DELETE", "BEGIN", "END", "EXIT", "NEXT",
  "RETURN", "FUNCTION", "INCLUDE", "$accept", "program", "program_block",
  "PA_block", "$@1", "$@2", "$@3", "$@4", "$@5", "block",
  "block_or_separator", "statement_list", "statement", "separator", "expr",
  "$@6", "$@7", "$@8", "$@9", "cat_expr", "p_expr", "lvalue", "arglist",
  "args", "builtin", "mark", "print", "pr_args", "arg2", "pr_direction",
  "if_front", "else", "do", "while_front", "for1", "for2", "for3",
  "array_loop_front", "field", "split_front", "split_back", "re_arg",
  "return_statement", "getline", "fvalue", "getline_file", "sub_or_gsub",
  "sub_back", "function_def", "funct_start", "funct_head", "f_arglist",
  "f_args", "outside_error", "call_args", "ca_front", "ca_back", "include", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    79,    80,    80,    81,    81,    81,    82,    82,    83,
      82,    84,    82,    85,    82,    86,    87,    82,    88,    88,
      89,    89,    90,    90,    91,    91,    91,    91,    91,    91,
      91,    91,    92,    92,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    94,
      93,    95,    93,    96,    97,    93,    98,    98,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,   100,   101,   101,
     102,   102,   103,   103,   104,    91,   105,   105,   106,   106,
     106,   107,   107,   108,   108,   109,    91,   110,    91,   111,
      91,   112,    91,    91,   113,   113,   114,   114,   115,   115,
      93,    93,   100,    99,    99,    91,    91,   116,    91,   117,
     117,   117,   117,   117,    99,    93,    93,    93,    93,    93,
      93,    93,    99,   118,   119,   119,    99,   120,    91,    91,
     121,   121,    99,    99,    99,    99,    99,   122,   123,   123,
     124,   124,    99,   125,   125,   126,   126,   127,   128,   129,
     129,   130,   130,   131,   131,   132,    99,    99,   133,   133,
     134,   134,   134,   135,   135,   136
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     2,     1,     1,     0,
       3,     0,     3,     0,     3,     0,     0,     6,     3,     3,
       1,     1,     1,     2,     1,     2,     1,     2,     2,     2,
       1,     2,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     0,
       4,     0,     4,     0,     0,     7,     1,     2,     1,     1,
       1,     3,     1,     3,     3,     3,     3,     3,     3,     2,
       2,     2,     1,     2,     2,     2,     2,     1,     0,     1,
       1,     3,     5,     1,     0,     5,     1,     1,     1,     3,
       2,     3,     3,     0,     2,     4,     2,     1,     4,     1,
       7,     4,     2,     4,     3,     4,     1,     2,     1,     2,
       3,     5,     5,     5,     6,     7,     3,     6,     2,     1,
       2,     6,     2,     3,     1,     3,     3,     3,     3,     3,
       3,     3,     2,     5,     1,     3,     6,     1,     2,     3,
       2,     3,     1,     2,     2,     3,     4,     1,     1,     1,
       2,     3,     6,     1,     1,     1,     3,     2,     4,     2,
       2,     0,     1,     1,     3,     1,     3,     3,     2,     2,
       1,     3,     3,     2,     2,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,   165,     0,   147,     0,     0,     0,     0,   119,     0,
       0,    58,    59,    62,    60,    84,    84,    84,    83,     0,
       0,   153,   154,     9,    11,     0,     0,     0,     2,     4,
       7,    13,    34,    56,     0,    72,   124,     0,   142,     0,
       0,     5,     0,     0,     0,     8,     0,    32,    33,    86,
      87,    99,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    24,     0,    22,    26,     0,    84,     0,     0,     0,
       0,     0,    30,     0,    60,    71,   124,    70,    69,     0,
      77,    74,    76,   120,   122,     0,     0,   124,    73,     0,
       0,     0,     0,     0,     0,     0,     0,   159,   160,     0,
       1,     3,    15,    53,    49,    51,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    57,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    75,     0,   134,
     132,   150,   148,   149,   143,   144,     0,   157,   161,     6,
      19,    27,     0,     0,    28,    29,     0,    84,   138,     0,
      31,   140,     0,     0,    18,    23,    25,    78,    96,     0,
     102,   106,     0,     0,   118,     0,     0,     0,     0,     0,
       0,    61,     0,     0,   123,     0,   170,   166,     0,   167,
      78,     0,     0,    10,    12,   175,     0,     0,     0,     0,
     110,    48,    47,    46,    45,    44,    43,    42,    20,    14,
      21,    64,    63,    67,    66,    65,   145,    68,    41,    40,
      39,    38,    37,    36,    35,   131,   130,   129,   128,   127,
     126,   125,     0,   151,   137,     0,   163,     0,   162,     0,
     104,    60,     0,     0,   116,     0,   139,   141,     0,    80,
      88,    79,    93,    97,     0,     0,   107,   108,     0,     0,
       0,     0,     0,    91,    92,     0,     0,   168,    60,     0,
     169,     0,     0,     0,    16,     0,    50,    52,   146,   135,
       0,   158,     0,   101,     0,   105,    95,     0,    90,     0,
       0,     0,     0,    98,     0,   109,   103,     0,     0,     0,
     111,   113,   172,   174,   171,   173,    82,   133,     0,     0,
      54,     0,   164,     0,     0,    89,    81,    94,    85,     0,
     113,   112,   121,   114,   136,    17,     0,     0,   155,   152,
     117,     0,     0,    55,     0,   115,   100,   156
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    27,    28,    29,    95,    96,   114,   196,   309,    61,
     209,    62,    63,    64,    65,   198,   199,   197,   326,    32,
      33,    34,   250,   251,    35,    89,    66,   252,    86,   292,
      67,   254,    68,    69,    70,   173,   259,    71,    36,    37,
     140,   235,    72,    38,   144,    39,    40,   329,    41,    42,
      43,   237,   238,    44,   187,   188,   270,    45
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -206
static const yytype_int16 yypact[] =
{
     330,  -206,   465,  -206,   815,   815,   815,   -17,  -206,   722,
     846,  -206,  -206,  -206,   290,  -206,  -206,  -206,  -206,   -31,
     -22,  -206,  -206,  -206,  -206,    12,   -11,   295,  -206,  -206,
    -206,  1085,   815,   140,  1024,  -206,   396,    -5,    17,   815,
      -4,  -206,    46,     7,    46,  -206,    35,  -206,  -206,  -206,
    -206,  -206,    13,    20,    28,    28,    71,     4,   604,    28,
     604,  -206,   393,  -206,  -206,   719,  -206,   537,   537,   537,
     635,   537,  -206,   846,    10,    49,    39,    49,    49,    30,
     136,  -206,  -206,   136,  -206,    74,     1,   717,  -206,   141,
     116,   116,   118,   846,   846,    46,    46,  -206,  -206,   163,
    -206,  -206,  -206,  -206,  -206,  -206,   120,   846,   846,   846,
     846,   846,   846,   846,    15,   140,   815,   815,   815,   815,
     815,   146,   815,   846,   846,   846,   846,   846,   846,   846,
     846,   846,   846,   846,   846,   846,   846,  -206,   846,  -206,
    -206,  -206,  -206,  -206,   142,    96,   846,  -206,   134,  -206,
    -206,  -206,   846,   666,  -206,  -206,   846,    28,  -206,   719,
    -206,  -206,   719,    28,  -206,  -206,  -206,   877,   117,   124,
    -206,  -206,  1038,   753,  -206,   593,   182,   145,   184,   185,
     846,  -206,   846,   171,  -206,   846,   153,  -206,   908,  -206,
     846,  1106,  1127,  -206,  -206,  -206,   846,   846,   846,   846,
    -206,   228,  -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,
    -206,    43,    43,    49,    49,    49,   -17,   162,   605,   605,
     605,   605,   605,   605,   605,   605,   605,   605,   605,   605,
     605,   605,   951,  -206,   605,   197,  -206,   164,   201,   962,
    -206,   225,  1064,   989,  -206,   200,  -206,  -206,   784,   605,
    -206,   202,   204,  -206,   537,   170,  -206,  -206,  1000,   537,
     846,   846,   846,   605,   605,   174,   137,  -206,   206,   454,
    -206,   180,   176,   846,   605,   538,   394,   975,  -206,  -206,
     846,  -206,   177,  -206,   179,  -206,  -206,   846,  -206,     2,
     846,   846,    28,  -206,   846,  -206,  -206,   147,   150,   152,
    -206,   474,  -206,  -206,  -206,  -206,  -206,  -206,   186,    15,
    -206,   526,  -206,   188,   160,   171,   605,   605,  -206,  1027,
     192,  -206,  -206,  -206,  -206,  -206,   846,   -17,  -206,  -206,
    -206,    28,    28,   605,   205,  -206,  -206,  -206
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -206,  -206,   218,  -206,  -206,  -206,  -206,  -206,  -206,    45,
     -77,  -206,   -53,    -8,     0,  -206,  -206,  -206,  -206,  -206,
     198,    -6,    57,  -118,  -206,     8,  -206,  -206,     3,  -206,
    -206,  -206,  -206,  -206,  -206,  -206,  -206,  -206,    -2,  -206,
    -206,   -10,  -206,  -206,  -205,  -206,  -206,  -206,  -206,  -206,
    -206,  -206,  -206,  -206,   173,  -206,  -206,  -206
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -113
static const yytype_int16 yytable[] =
{
      31,    81,    76,    76,    76,    82,   138,    76,    87,   165,
      85,   278,   182,   182,   168,   169,   170,    93,   174,   -84,
      47,    48,     2,    90,    91,    92,    94,    31,     8,     9,
      76,    79,   142,    47,    48,    80,   143,    76,   151,    99,
      47,    48,   139,   150,   146,    30,   154,   155,   183,   315,
     158,   160,   161,     2,    88,   148,   157,   166,   159,   141,
     162,   152,     8,     9,    97,    79,    98,   266,   153,    80,
     172,    87,    30,   175,   167,     8,     9,   177,    79,   118,
     119,   120,   176,   137,   121,   180,   122,   147,   178,   149,
     121,   179,   122,   191,   192,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   210,   201,   202,   203,
     204,   205,   206,   207,    76,    76,    76,    76,    76,   156,
      76,   181,   334,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,  -113,   232,   122,
     193,   194,   297,   298,   299,   -84,   234,   301,   290,   244,
     185,   246,   239,   242,   247,   151,   243,   320,   290,   208,
     321,   290,   322,   290,   186,   245,   190,   249,   195,   314,
     331,   290,   200,   258,   116,   117,   118,   119,   120,   216,
     263,   121,   264,   122,   233,   249,   236,   253,   269,   255,
     249,   260,   184,   261,   262,   265,   274,   275,   276,   277,
     267,   293,    75,    77,    78,   122,   296,    84,   280,   287,
     142,   281,   282,   290,   143,   -84,   291,   302,   294,   -77,
     -77,   -77,   -77,   -77,   -77,   -77,   300,   306,   307,   312,
     115,   313,   325,   324,   -84,   330,   323,   145,   -77,   -77,
     -77,   -77,   -77,   -77,   -77,   101,    87,   271,    85,   284,
      88,   289,   337,   303,   108,   109,   110,   111,   112,   113,
     249,   249,   249,   308,   189,     0,     0,     0,     0,    88,
       0,     0,     0,   234,     0,     0,     0,     0,     0,     0,
     311,     0,     0,     0,   318,     0,     0,   249,     0,     0,
     316,   317,     0,     0,   319,   100,     1,     0,     0,   -84,
       0,   210,     2,   -77,   -77,   -77,   -77,   -77,   -77,   -77,
       0,     0,     0,     0,   211,   212,   213,   214,   215,     0,
     217,   142,     0,   335,   336,   143,   333,     0,     3,     4,
       5,     1,     0,     0,    88,     6,     0,     2,     0,     7,
       8,     9,     0,    10,    11,    12,    13,    14,     0,    15,
      16,    17,    18,     0,   208,    19,    20,    21,    22,     0,
       0,     0,     0,     3,     4,     5,     0,    23,    24,     0,
       6,     0,    25,    26,     7,     8,     9,     0,    10,    11,
      12,    13,    14,     0,    15,    16,    17,    18,     0,     0,
      19,    20,    21,    22,   163,     0,     0,     0,    47,    48,
       2,   164,    23,    24,     0,     0,     0,    25,    26,   130,
     131,   132,   133,   134,   135,   136,     0,   105,   106,   107,
     108,   109,   110,   111,   112,   113,     3,     4,     5,     0,
       0,     0,     0,     6,     0,     0,     0,     7,     8,     9,
     137,    10,    11,    12,    13,    14,     0,    15,    16,    17,
      18,    49,    50,    19,    20,    21,    22,    51,    52,    53,
      54,    55,    56,     0,    57,   304,    46,    58,    59,    60,
      47,    48,     2,     0,     0,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,     0,  -112,  -112,  -112,
    -112,  -112,  -112,  -112,     0,     0,     0,     0,     3,     4,
       5,   305,     0,     0,     0,     6,     0,     0,     0,     7,
       8,     9,     0,    10,    11,    12,    13,    14,   323,    15,
      16,    17,    18,    49,    50,    19,    20,    21,    22,    51,
      52,    53,    54,    55,    56,     0,    57,   327,   163,    58,
      59,    60,    47,    48,     2,     0,     0,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   310,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
       3,     4,     5,   328,     0,     0,     0,     6,     0,     0,
       0,     7,     8,     9,     0,    10,    11,    12,    13,    14,
       0,    15,    16,    17,    18,    49,    50,    19,    20,    21,
      22,    51,    52,    53,    54,    55,    56,     0,    57,    47,
      48,    58,    59,    60,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,     0,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,     3,     4,     5,
     181,   171,     0,     0,     6,     0,     0,     0,     7,     8,
       9,     0,    10,    11,    12,    13,    14,     0,    15,    16,
      17,    18,     0,     0,    19,    20,    21,    22,     3,     4,
       5,     0,   240,     0,     0,     6,     0,     0,     0,     7,
       8,     9,     0,    10,    11,    12,    13,    14,     0,    15,
      16,    17,    18,     0,     0,    19,    20,    21,    22,     3,
       4,     5,     0,     0,     0,     0,     6,     0,     0,     0,
       7,     8,     9,     0,    10,    11,    12,    13,   241,     0,
      15,    16,    17,    18,    47,    48,    19,    20,    21,    22,
     130,   131,   132,   133,   134,   135,   136,     0,     0,     0,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,     0,     0,     0,     0,     3,     4,     5,     0,     0,
       0,   137,     6,     0,   184,     0,     7,     8,     9,     0,
      73,    11,    12,    13,    74,    83,    15,    16,    17,    18,
       0,     0,    19,    20,    21,    22,     3,     4,     5,     0,
       0,     0,     0,     6,     0,     0,     0,     7,     8,     9,
     257,    10,    11,    12,    13,    14,     0,    15,    16,    17,
      18,     0,     0,    19,    20,    21,    22,     3,     4,     5,
       0,     0,     0,     0,     6,     0,     0,     0,     7,     8,
       9,   288,    10,    11,    12,    13,    14,     0,    15,    16,
      17,    18,     0,     0,    19,    20,    21,    22,     3,     4,
       5,     0,     0,     0,     0,     6,     0,     0,     0,     7,
       8,     9,     0,    73,    11,    12,    13,    74,     0,    15,
      16,    17,    18,     0,     0,    19,    20,    21,    22,     3,
       4,     5,     0,     0,     0,     0,     6,     0,     0,     0,
       7,     8,     9,     0,    10,    11,    12,    13,    14,     0,
      15,    16,    17,    18,     0,     0,    19,    20,    21,    22,
       3,     4,     5,     0,     0,     0,     0,     6,     0,     0,
       0,     7,     8,     9,     0,   248,    11,    12,    13,    14,
       0,    15,    16,    17,    18,     0,     0,    19,    20,    21,
      22,     3,     4,     5,     0,     0,     0,     0,     6,     0,
       0,     0,     7,     8,     9,     0,    10,    11,    12,    13,
     268,     0,    15,    16,    17,    18,     0,     0,    19,    20,
      21,    22,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,     0,     0,     0,     0,   279,   106,
     107,   108,   109,   110,   111,   112,   113,     0,     0,   283,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,     0,     0,     0,     0,   286,   123,   124,   125,
     126,   127,   128,   129,   256,     0,     0,   295,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     285,     0,     0,     0,   332,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   102,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   272,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   273,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113
};

static const yytype_int16 yycheck[] =
{
       0,     7,     4,     5,     6,     7,    11,     9,    10,    62,
      10,   216,    11,    11,    67,    68,    69,    48,    71,     9,
       5,     6,     7,    15,    16,    17,    48,    27,    45,    46,
      32,    48,    38,     5,     6,    52,    38,    39,    46,    50,
       5,     6,    47,     8,    48,     0,    54,    55,    47,    47,
      58,    59,    60,     7,    44,    48,    52,    65,    58,    42,
      60,    48,    45,    46,    52,    48,    54,   185,    48,    52,
      70,    73,    27,    73,    66,    45,    46,    79,    48,    36,
      37,    38,    74,    44,    41,    11,    43,    42,    80,    44,
      41,    83,    43,    93,    94,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,   114,   107,   108,   109,
     110,   111,   112,   113,   116,   117,   118,   119,   120,    48,
     122,    47,   327,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,    41,   138,    43,
      95,    96,   260,   261,   262,     9,   146,    10,    11,   157,
       9,   159,   152,   153,   162,   163,   156,    10,    11,   114,
      10,    11,    10,    11,    48,   157,    48,   167,     5,   287,
      10,    11,    52,   173,    34,    35,    36,    37,    38,    33,
     180,    41,   182,    43,    42,   185,    52,    70,   188,    65,
     190,     9,    47,     9,     9,    24,   196,   197,   198,   199,
      47,   254,     4,     5,     6,    43,   259,     9,    11,     9,
     216,    47,    11,    11,   216,     9,    12,    11,    48,    13,
      14,    15,    16,    17,    18,    19,    52,    47,    52,    52,
      32,    52,   309,    47,     9,    47,    44,    39,    13,    14,
      15,    16,    17,    18,    19,    27,   248,   190,   248,    24,
      44,   248,    47,    47,    26,    27,    28,    29,    30,    31,
     260,   261,   262,   273,    91,    -1,    -1,    -1,    -1,    44,
      -1,    -1,    -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,
     280,    -1,    -1,    -1,   292,    -1,    -1,   287,    -1,    -1,
     290,   291,    -1,    -1,   294,     0,     1,    -1,    -1,     9,
      -1,   309,     7,    13,    14,    15,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,   116,   117,   118,   119,   120,    -1,
     122,   327,    -1,   331,   332,   327,   326,    -1,    33,    34,
      35,     1,    -1,    -1,    44,    40,    -1,     7,    -1,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    -1,   309,    60,    61,    62,    63,    -1,
      -1,    -1,    -1,    33,    34,    35,    -1,    72,    73,    -1,
      40,    -1,    77,    78,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    -1,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    63,     1,    -1,    -1,    -1,     5,     6,
       7,     8,    72,    73,    -1,    -1,    -1,    77,    78,    13,
      14,    15,    16,    17,    18,    19,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    33,    34,    35,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    44,    45,    46,
      44,    48,    49,    50,    51,    52,    -1,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    -1,    71,    11,     1,    74,    75,    76,
       5,     6,     7,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    -1,    13,    14,    15,
      16,    17,    18,    19,    -1,    -1,    -1,    -1,    33,    34,
      35,    47,    -1,    -1,    -1,    40,    -1,    -1,    -1,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    44,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    -1,    71,    11,     1,    74,
      75,    76,     5,     6,     7,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      33,    34,    35,    47,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    -1,    71,     5,
       6,    74,    75,    76,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    33,    34,    35,
      47,     6,    -1,    -1,    40,    -1,    -1,    -1,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    33,    34,
      35,    -1,     6,    -1,    -1,    40,    -1,    -1,    -1,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    33,
      34,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    56,    57,     5,     6,    60,    61,    62,    63,
      13,    14,    15,    16,    17,    18,    19,    -1,    -1,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    -1,    -1,    -1,    -1,    33,    34,    35,    -1,    -1,
      -1,    44,    40,    -1,    47,    -1,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    63,    33,    34,    35,    -1,
      -1,    -1,    -1,    40,    -1,    -1,    -1,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    -1,    54,    55,    56,
      57,    -1,    -1,    60,    61,    62,    63,    33,    34,    35,
      -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    -1,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    63,    33,    34,
      35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    -1,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    63,    33,
      34,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    -1,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    63,
      33,    34,    35,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      -1,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      63,    33,    34,    35,    -1,    -1,    -1,    -1,    40,    -1,
      -1,    -1,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    -1,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    63,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    -1,    -1,    -1,    -1,    47,    24,
      25,    26,    27,    28,    29,    30,    31,    -1,    -1,    47,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    -1,    -1,    -1,    -1,    47,    13,    14,    15,
      16,    17,    18,    19,     6,    -1,    -1,    47,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
       6,    -1,    -1,    -1,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    11,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     7,    33,    34,    35,    40,    44,    45,    46,
      48,    49,    50,    51,    52,    54,    55,    56,    57,    60,
      61,    62,    63,    72,    73,    77,    78,    80,    81,    82,
      88,    93,    98,    99,   100,   103,   117,   118,   122,   124,
     125,   127,   128,   129,   132,   136,     1,     5,     6,    58,
      59,    64,    65,    66,    67,    68,    69,    71,    74,    75,
      76,    88,    90,    91,    92,    93,   105,   109,   111,   112,
     113,   116,   121,    48,    52,    99,   117,    99,    99,    48,
      52,   100,   117,    53,    99,    93,   107,   117,    44,   104,
     104,   104,   104,    48,    48,    83,    84,    52,    54,    50,
       0,    81,    11,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    85,    99,    34,    35,    36,    37,
      38,    41,    43,    13,    14,    15,    16,    17,    18,    19,
      13,    14,    15,    16,    17,    18,    19,    44,    11,    47,
     119,    42,   100,   117,   123,    99,    48,    88,    48,    88,
       8,    92,    48,    48,    92,    92,    48,    52,    92,    93,
      92,    92,    93,     1,     8,    91,    92,   104,    91,    91,
      91,     6,    93,   114,    91,    93,   104,   117,   104,   104,
      11,    47,    11,    47,    47,     9,    48,   133,   134,   133,
      48,    93,    93,    88,    88,     5,    86,    96,    94,    95,
      52,    93,    93,    93,    93,    93,    93,    93,    88,    89,
      92,    99,    99,    99,    99,    99,    33,    99,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    42,    93,   120,    52,   130,   131,    93,
       6,    52,    93,    93,    92,   104,    92,    92,    48,    93,
     101,   102,   106,    70,   110,    65,     6,    47,    93,   115,
       9,     9,     9,    93,    93,    24,   102,    47,    52,    93,
     135,   101,    11,    11,    93,    93,    93,    93,   123,    47,
      11,    47,    11,    47,    24,     6,    47,     9,    47,   107,
      11,    12,   108,    91,    48,    47,    91,   102,   102,   102,
      52,    10,    11,    47,    11,    47,    47,    52,   120,    87,
      20,    93,    52,    52,   102,    47,    93,    93,    92,    93,
      10,    10,    10,    44,    47,    89,    97,    11,    47,   126,
      47,    10,    47,    93,   123,    92,    92,    47
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (MAWK, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, MAWK)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, MAWK); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, mawk_state_t *MAWK)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, MAWK)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    mawk_state_t *MAWK;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (MAWK);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, mawk_state_t *MAWK)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, MAWK)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    mawk_state_t *MAWK;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, MAWK);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule, mawk_state_t *MAWK)
#else
static void
yy_reduce_print (yyvsp, yyrule, MAWK)
    YYSTYPE *yyvsp;
    int yyrule;
    mawk_state_t *MAWK;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       , MAWK);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule, MAWK); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, mawk_state_t *MAWK)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, MAWK)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    mawk_state_t *MAWK;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (MAWK);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (mawk_state_t *MAWK);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (mawk_state_t *MAWK)
#else
int
yyparse (MAWK)
    mawk_state_t *MAWK;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 7:

/* Line 1455 of yacc.c  */
#line 216 "parse.y"
    { /* this do nothing action removes a vacuous warning
                  from Bison */
             }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 223 "parse.y"
    { mawk_be_setup(MAWK, MAWK->scope = SCOPE_BEGIN) ; }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 226 "parse.y"
    { switch_code_to_main(MAWK) ; }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 229 "parse.y"
    { mawk_be_setup(MAWK, MAWK->scope = SCOPE_END) ; }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 232 "parse.y"
    { switch_code_to_main(MAWK) ; }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 235 "parse.y"
    { mawk_code_jmp(MAWK, _JZ, (INST*)0) ; }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 238 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr ) ; }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 242 "parse.y"
    { 
	       INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;
             int len ;

	       mawk_code_push(MAWK, p1, mawk_code_ptr - p1, MAWK->scope, MAWK->active_funct) ;
               mawk_code_ptr = p1 ;

               mawk_code2op(MAWK, _RANGE, 1) ;
               mawk_code_ptr += 3 ;
               len = mawk_code_pop(MAWK, mawk_code_ptr) ;
             mawk_code_ptr += len ;
               code1(_STOP) ;
             p1 = CDP((yyvsp[(1) - (2)].start)) ;
               p1[2].op = mawk_code_ptr - (p1+1) ;
             }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 258 "parse.y"
    { code1(_STOP) ; }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 261 "parse.y"
    { 
	       INST *p1 = CDP((yyvsp[(1) - (6)].start)) ;
	       
	       p1[3].op = CDP((yyvsp[(6) - (6)].start)) - (p1+1) ;
               p1[4].op = mawk_code_ptr - (p1+1) ;
             }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 272 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 274 "parse.y"
    { (yyval.start) = mawk_code_offset ; /* does nothing won't be mawk_executed */
              MAWK->print_flag = MAWK->getline_flag = MAWK->paren_cnt = 0 ;
              yyerrok ; }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 281 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                       code1(_PUSHINT) ; code1(0) ;
                       code2(MAWK, _PRINT, mawk_bi_print) ;
                     }
    break;

  case 25:

/* Line 1455 of yacc.c  */
#line 293 "parse.y"
    { code1(_POP) ; }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 295 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 297 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                MAWK->print_flag = MAWK->getline_flag = 0 ;
                MAWK->paren_cnt = 0 ;
                yyerrok ;
              }
    break;

  case 28:

/* Line 1455 of yacc.c  */
#line 303 "parse.y"
    { (yyval.start) = mawk_code_offset ; mawk_BC_insert(MAWK, 'B', mawk_code_ptr+1) ;
               code2(MAWK, _JMP, 0) /* don't use mawk_code_jmp ! */ ; }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 306 "parse.y"
    { (yyval.start) = mawk_code_offset ; mawk_BC_insert(MAWK, 'C', mawk_code_ptr+1) ;
               code2(MAWK, _JMP, 0) ; }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 309 "parse.y"
    { if ( MAWK->scope != SCOPE_FUNCT )
                     mawk_compile_error(MAWK, "return outside function body") ;
             }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 313 "parse.y"
    { if ( MAWK->scope != SCOPE_MAIN )
                   mawk_compile_error(MAWK, "improper use of next" ) ;
                (yyval.start) = mawk_code_offset ; 
                code1(_NEXT) ;
              }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 324 "parse.y"
    { code1(_ASSIGN) ; }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 325 "parse.y"
    { code1(_ADD_ASG) ; }
    break;

  case 37:

/* Line 1455 of yacc.c  */
#line 326 "parse.y"
    { code1(_SUB_ASG) ; }
    break;

  case 38:

/* Line 1455 of yacc.c  */
#line 327 "parse.y"
    { code1(_MUL_ASG) ; }
    break;

  case 39:

/* Line 1455 of yacc.c  */
#line 328 "parse.y"
    { code1(_DIV_ASG) ; }
    break;

  case 40:

/* Line 1455 of yacc.c  */
#line 329 "parse.y"
    { code1(_MOD_ASG) ; }
    break;

  case 41:

/* Line 1455 of yacc.c  */
#line 330 "parse.y"
    { code1(_POW_ASG) ; }
    break;

  case 42:

/* Line 1455 of yacc.c  */
#line 331 "parse.y"
    { code1(_EQ) ; }
    break;

  case 43:

/* Line 1455 of yacc.c  */
#line 332 "parse.y"
    { code1(_NEQ) ; }
    break;

  case 44:

/* Line 1455 of yacc.c  */
#line 333 "parse.y"
    { code1(_LT) ; }
    break;

  case 45:

/* Line 1455 of yacc.c  */
#line 334 "parse.y"
    { code1(_LTE) ; }
    break;

  case 46:

/* Line 1455 of yacc.c  */
#line 335 "parse.y"
    { code1(_GT) ; }
    break;

  case 47:

/* Line 1455 of yacc.c  */
#line 336 "parse.y"
    { code1(_GTE) ; }
    break;

  case 48:

/* Line 1455 of yacc.c  */
#line 339 "parse.y"
    {
	    INST *p3 = CDP((yyvsp[(3) - (3)].start)) ;

            if ( p3 == mawk_code_ptr - 2 )
            {
               if ( p3->op == _MATCH0 )  p3->op = _MATCH1 ;

               else /* check for string */
               if ( p3->op == _PUSHS )
               { CELL *cp = ZMALLOC(CELL) ;

                 cp->type = C_STRING ; 
                 cp->ptr = p3[1].ptr ;
                 mawk_cast_to_RE(MAWK, cp) ;
                 mawk_code_ptr -= 2 ;
                 code2(MAWK, _MATCH1, cp->ptr) ;
                 ZFREE(cp) ;
               }
               else  code1(_MATCH2) ;
            }
            else code1(_MATCH2) ;

            if ( !(yyvsp[(2) - (3)].ival) ) code1(_NOT) ;
          }
    break;

  case 49:

/* Line 1455 of yacc.c  */
#line 366 "parse.y"
    { code1(_TEST) ;
                mawk_code_jmp(MAWK, _LJNZ, (INST*)0) ;
              }
    break;

  case 50:

/* Line 1455 of yacc.c  */
#line 370 "parse.y"
    { code1(_TEST) ; mawk_patch_jmp(MAWK, mawk_code_ptr) ; }
    break;

  case 51:

/* Line 1455 of yacc.c  */
#line 373 "parse.y"
    { code1(_TEST) ; 
		mawk_code_jmp(MAWK, _LJZ, (INST*)0) ;
	      }
    break;

  case 52:

/* Line 1455 of yacc.c  */
#line 377 "parse.y"
    { code1(_TEST) ; mawk_patch_jmp(MAWK, mawk_code_ptr) ; }
    break;

  case 53:

/* Line 1455 of yacc.c  */
#line 379 "parse.y"
    { mawk_code_jmp(MAWK, _JZ, (INST*)0) ; }
    break;

  case 54:

/* Line 1455 of yacc.c  */
#line 380 "parse.y"
    { mawk_code_jmp(MAWK, _JMP, (INST*)0) ; }
    break;

  case 55:

/* Line 1455 of yacc.c  */
#line 382 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr) ; mawk_patch_jmp(MAWK, CDP((yyvsp[(7) - (7)].start))) ; }
    break;

  case 57:

/* Line 1455 of yacc.c  */
#line 387 "parse.y"
    { code1(_CAT) ; }
    break;

  case 58:

/* Line 1455 of yacc.c  */
#line 391 "parse.y"
    {  (yyval.start) = mawk_code_offset ; code2(MAWK, _PUSHD, (yyvsp[(1) - (1)].ptr)) ; }
    break;

  case 59:

/* Line 1455 of yacc.c  */
#line 393 "parse.y"
    { (yyval.start) = mawk_code_offset ; code2(MAWK, _PUSHS, (yyvsp[(1) - (1)].ptr)) ; }
    break;

  case 60:

/* Line 1455 of yacc.c  */
#line 395 "parse.y"
    { check_var(MAWK, (yyvsp[(1) - (1)].stp)) ;
            (yyval.start) = mawk_code_offset ;
            if ( is_local((yyvsp[(1) - (1)].stp)) )
            { mawk_code2op(MAWK, L_PUSHI, (yyvsp[(1) - (1)].stp)->offset) ; }
            else code2(MAWK, _PUSHI, (yyvsp[(1) - (1)].stp)->stval.cp) ;
          }
    break;

  case 61:

/* Line 1455 of yacc.c  */
#line 403 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 62:

/* Line 1455 of yacc.c  */
#line 407 "parse.y"
    { (yyval.start) = mawk_code_offset ; code2(MAWK, _MATCH0, (yyvsp[(1) - (1)].ptr)) ; }
    break;

  case 63:

/* Line 1455 of yacc.c  */
#line 410 "parse.y"
    { code1(_ADD) ; }
    break;

  case 64:

/* Line 1455 of yacc.c  */
#line 411 "parse.y"
    { code1(_SUB) ; }
    break;

  case 65:

/* Line 1455 of yacc.c  */
#line 412 "parse.y"
    { code1(_MUL) ; }
    break;

  case 66:

/* Line 1455 of yacc.c  */
#line 413 "parse.y"
    { code1(_DIV) ; }
    break;

  case 67:

/* Line 1455 of yacc.c  */
#line 414 "parse.y"
    { code1(_MOD) ; }
    break;

  case 68:

/* Line 1455 of yacc.c  */
#line 415 "parse.y"
    { code1(_POW) ; }
    break;

  case 69:

/* Line 1455 of yacc.c  */
#line 417 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; code1(_NOT) ; }
    break;

  case 70:

/* Line 1455 of yacc.c  */
#line 419 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; code1(_UPLUS) ; }
    break;

  case 71:

/* Line 1455 of yacc.c  */
#line 421 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; code1(_UMINUS) ; }
    break;

  case 73:

/* Line 1455 of yacc.c  */
#line 426 "parse.y"
    { check_var(MAWK, (yyvsp[(1) - (2)].stp)) ;
             (yyval.start) = mawk_code_offset ;
             mawk_code_address((yyvsp[(1) - (2)].stp)) ;

             if ( (yyvsp[(2) - (2)].ival) == '+' )  code1(_POST_INC) ;
             else  code1(_POST_DEC) ;
           }
    break;

  case 74:

/* Line 1455 of yacc.c  */
#line 434 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; 
              if ( (yyvsp[(1) - (2)].ival) == '+' ) code1(_PRE_INC) ;
              else  code1(_PRE_DEC) ;
            }
    break;

  case 75:

/* Line 1455 of yacc.c  */
#line 441 "parse.y"
    { if ((yyvsp[(2) - (2)].ival) == '+' ) code1(F_POST_INC ) ; 
             else  code1(F_POST_DEC) ;
           }
    break;

  case 76:

/* Line 1455 of yacc.c  */
#line 445 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ; 
             if ( (yyvsp[(1) - (2)].ival) == '+' ) code1(F_PRE_INC) ;
             else  code1( F_PRE_DEC) ; 
           }
    break;

  case 77:

/* Line 1455 of yacc.c  */
#line 452 "parse.y"
    { (yyval.start) = mawk_code_offset ; 
          check_var(MAWK, (yyvsp[(1) - (1)].stp)) ;
          mawk_code_address((yyvsp[(1) - (1)].stp)) ;
        }
    break;

  case 78:

/* Line 1455 of yacc.c  */
#line 460 "parse.y"
    { (yyval.ival) = 0 ; }
    break;

  case 80:

/* Line 1455 of yacc.c  */
#line 465 "parse.y"
    { (yyval.ival) = 1 ; }
    break;

  case 81:

/* Line 1455 of yacc.c  */
#line 467 "parse.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) + 1 ; }
    break;

  case 82:

/* Line 1455 of yacc.c  */
#line 472 "parse.y"
    { const BI_REC *p = (yyvsp[(1) - (5)].bip) ;
          (yyval.start) = (yyvsp[(2) - (5)].start) ;
          if ( (int)p->min_args > (yyvsp[(4) - (5)].ival) || (int)p->max_args < (yyvsp[(4) - (5)].ival) )
            mawk_compile_error(
            MAWK, "wrong number of arguments in call to %s" ,
            p->name ) ;
          if ( p->min_args != p->max_args ) /* variable args */
              { code1(_PUSHINT) ;  code1((yyvsp[(4) - (5)].ival)) ; }
          code2(MAWK, _BUILTIN , p->fp) ;
        }
    break;

  case 83:

/* Line 1455 of yacc.c  */
#line 483 "parse.y"
    {
	    (yyval.start) = mawk_code_offset ;
	    code1(_PUSHINT) ; code1(0) ;
	    code2(MAWK, _BUILTIN, (yyvsp[(1) - (1)].bip)->fp) ;
	  }
    break;

  case 84:

/* Line 1455 of yacc.c  */
#line 492 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 85:

/* Line 1455 of yacc.c  */
#line 496 "parse.y"
    { code2(MAWK, _PRINT, (yyvsp[(1) - (5)].fp)) ; 
              if ( (yyvsp[(1) - (5)].fp) == mawk_bi_printf && (yyvsp[(3) - (5)].ival) == 0 )
                    mawk_compile_error(MAWK, "no arguments in call to printf") ;
              MAWK->print_flag = 0 ;
              (yyval.start) = (yyvsp[(2) - (5)].start) ;
            }
    break;

  case 86:

/* Line 1455 of yacc.c  */
#line 504 "parse.y"
    { (yyval.fp) = mawk_bi_print ; MAWK->print_flag = 1 ;}
    break;

  case 87:

/* Line 1455 of yacc.c  */
#line 505 "parse.y"
    { (yyval.fp) = mawk_bi_printf ; MAWK->print_flag = 1 ; }
    break;

  case 88:

/* Line 1455 of yacc.c  */
#line 508 "parse.y"
    { mawk_code2op(MAWK, _PUSHINT, (yyvsp[(1) - (1)].ival)) ; }
    break;

  case 89:

/* Line 1455 of yacc.c  */
#line 510 "parse.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].arg2p)->cnt ; zfree(MAWK, (yyvsp[(2) - (3)].arg2p),sizeof(ARG2_REC)) ; 
             mawk_code2op(MAWK, _PUSHINT, (yyval.ival)) ; 
           }
    break;

  case 90:

/* Line 1455 of yacc.c  */
#line 514 "parse.y"
    { (yyval.ival)=0 ; mawk_code2op(MAWK, _PUSHINT, 0) ; }
    break;

  case 91:

/* Line 1455 of yacc.c  */
#line 518 "parse.y"
    { (yyval.arg2p) = (ARG2_REC*) zmalloc(MAWK, sizeof(ARG2_REC)) ;
             (yyval.arg2p)->start = (yyvsp[(1) - (3)].start) ;
             (yyval.arg2p)->cnt = 2 ;
           }
    break;

  case 92:

/* Line 1455 of yacc.c  */
#line 523 "parse.y"
    { (yyval.arg2p) = (yyvsp[(1) - (3)].arg2p) ; (yyval.arg2p)->cnt++ ; }
    break;

  case 94:

/* Line 1455 of yacc.c  */
#line 528 "parse.y"
    { mawk_code2op(MAWK, _PUSHINT, (yyvsp[(1) - (2)].ival)) ; }
    break;

  case 95:

/* Line 1455 of yacc.c  */
#line 535 "parse.y"
    {  (yyval.start) = (yyvsp[(3) - (4)].start) ; mawk_eat_nl(MAWK, &yylval) ; mawk_code_jmp(MAWK, _JZ, (INST*)0) ; }
    break;

  case 96:

/* Line 1455 of yacc.c  */
#line 540 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr ) ;  }
    break;

  case 97:

/* Line 1455 of yacc.c  */
#line 543 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_code_jmp(MAWK, _JMP, (INST*)0) ; }
    break;

  case 98:

/* Line 1455 of yacc.c  */
#line 548 "parse.y"
    { mawk_patch_jmp(MAWK, mawk_code_ptr) ; 
		  mawk_patch_jmp(MAWK, CDP((yyvsp[(4) - (4)].start))) ; 
		}
    break;

  case 99:

/* Line 1455 of yacc.c  */
#line 556 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ; }
    break;

  case 100:

/* Line 1455 of yacc.c  */
#line 561 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (7)].start) ;
          mawk_code_jmp(MAWK, _JNZ, CDP((yyvsp[(2) - (7)].start))) ; 
          mawk_BC_clear(MAWK, mawk_code_ptr, CDP((yyvsp[(5) - (7)].start))) ; }
    break;

  case 101:

/* Line 1455 of yacc.c  */
#line 567 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ;
                  (yyval.start) = (yyvsp[(3) - (4)].start) ;

                  /* check if const expression */
                  if ( mawk_code_ptr - 2 == CDP((yyvsp[(3) - (4)].start)) &&
                       mawk_code_ptr[-2].op == _PUSHD &&
                       *(double*)mawk_code_ptr[-1].ptr != 0.0 
                     )
                     mawk_code_ptr -= 2 ;
                  else
		  { INST *p3 = CDP((yyvsp[(3) - (4)].start)) ;
		    mawk_code_push(MAWK, p3, mawk_code_ptr-p3, MAWK->scope, MAWK->active_funct) ;
		    mawk_code_ptr = p3 ;
                    code2(MAWK, _JMP, (INST*)0) ; /* code2() not mawk_code_jmp() */
		  }
                }
    break;

  case 102:

/* Line 1455 of yacc.c  */
#line 587 "parse.y"
    { 
		  int  saved_offset ;
		  int len ;
		  INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;
		  INST *p2 = CDP((yyvsp[(2) - (2)].start)) ;

                  if ( p1 != p2 )  /* real mawk_test in loop */
		  {
		    p1[1].op = mawk_code_ptr-(p1+1) ;
		    saved_offset = mawk_code_offset ;
		    len = mawk_code_pop(MAWK, mawk_code_ptr) ;
		    mawk_code_ptr += len ;
		    mawk_code_jmp(MAWK, _JNZ, CDP((yyvsp[(2) - (2)].start))) ;
		    mawk_BC_clear(MAWK, mawk_code_ptr, CDP(saved_offset)) ;
		  }
		  else /* while(1) */
		  {
		    mawk_code_jmp(MAWK, _JMP, p1) ;
		    mawk_BC_clear(MAWK, mawk_code_ptr, CDP((yyvsp[(2) - (2)].start))) ;
		  }
                }
    break;

  case 103:

/* Line 1455 of yacc.c  */
#line 613 "parse.y"
    { 
		  int cont_offset = mawk_code_offset ;
                  unsigned len = mawk_code_pop(MAWK, mawk_code_ptr) ;
		  INST *p2 = CDP((yyvsp[(2) - (4)].start)) ;
		  INST *p4 = CDP((yyvsp[(4) - (4)].start)) ;

                  mawk_code_ptr += len ;

		  if ( p2 != p4 )  /* real mawk_test in for2 */
		  {
                    p4[-1].op = mawk_code_ptr - p4 + 1 ;
		    len = mawk_code_pop(MAWK, mawk_code_ptr) ;
		    mawk_code_ptr += len ;
                    mawk_code_jmp(MAWK, _JNZ, CDP((yyvsp[(4) - (4)].start))) ;
		  }
		  else /*  for(;;) */
		  mawk_code_jmp(MAWK, _JMP, p4) ;

		  mawk_BC_clear(MAWK, mawk_code_ptr, CDP(cont_offset)) ;

                }
    break;

  case 104:

/* Line 1455 of yacc.c  */
#line 636 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 105:

/* Line 1455 of yacc.c  */
#line 638 "parse.y"
    { (yyval.start) = (yyvsp[(3) - (4)].start) ; code1(_POP) ; }
    break;

  case 106:

/* Line 1455 of yacc.c  */
#line 641 "parse.y"
    { (yyval.start) = mawk_code_offset ; }
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 643 "parse.y"
    { 
             if ( mawk_code_ptr - 2 == CDP((yyvsp[(1) - (2)].start)) &&
                  mawk_code_ptr[-2].op == _PUSHD &&
                  * (double*) mawk_code_ptr[-1].ptr != 0.0
                )
                    mawk_code_ptr -= 2 ;
             else   
	     {
	       INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;
	       mawk_code_push(MAWK, p1, mawk_code_ptr-p1, MAWK->scope, MAWK->active_funct) ;
	       mawk_code_ptr = p1 ;
	       code2(MAWK, _JMP, (INST*)0) ;
	     }
           }
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 660 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ;
	     mawk_code_push(MAWK, (INST*)0,0, MAWK->scope, MAWK->active_funct) ;
	   }
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 664 "parse.y"
    { INST *p1 = CDP((yyvsp[(1) - (2)].start)) ;

	     mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ; 
             code1(_POP) ;
             mawk_code_push(MAWK, p1, mawk_code_ptr - p1, MAWK->scope, MAWK->active_funct) ;
             mawk_code_ptr -= mawk_code_ptr - p1 ;
           }
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 677 "parse.y"
    { check_array(MAWK, (yyvsp[(3) - (3)].stp)) ;
             mawk_code_array(MAWK, (yyvsp[(3) - (3)].stp)) ; 
             code1(A_TEST) ; 
            }
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 682 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (5)].arg2p)->start ;
             mawk_code2op(MAWK, A_CAT, (yyvsp[(2) - (5)].arg2p)->cnt) ;
             zfree(MAWK, (yyvsp[(2) - (5)].arg2p), sizeof(ARG2_REC)) ;

             check_array(MAWK, (yyvsp[(5) - (5)].stp)) ;
             mawk_code_array(MAWK, (yyvsp[(5) - (5)].stp)) ;
             code1(A_TEST) ;
           }
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 693 "parse.y"
    { 
             if ( (yyvsp[(4) - (5)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT, (yyvsp[(4) - (5)].ival)) ; }

             check_array(MAWK, (yyvsp[(1) - (5)].stp)) ;
             if( is_local((yyvsp[(1) - (5)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHA, (yyvsp[(1) - (5)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHA, (yyvsp[(1) - (5)].stp)->stval.array) ;
             (yyval.start) = (yyvsp[(2) - (5)].start) ;
           }
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 706 "parse.y"
    { 
             if ( (yyvsp[(4) - (5)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT, (yyvsp[(4) - (5)].ival)) ; }

             check_array(MAWK, (yyvsp[(1) - (5)].stp)) ;
             if( is_local((yyvsp[(1) - (5)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHI, (yyvsp[(1) - (5)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHI, (yyvsp[(1) - (5)].stp)->stval.array) ;
             (yyval.start) = (yyvsp[(2) - (5)].start) ;
           }
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 718 "parse.y"
    { 
             if ( (yyvsp[(4) - (6)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT,(yyvsp[(4) - (6)].ival)) ; }

             check_array(MAWK, (yyvsp[(1) - (6)].stp)) ;
             if( is_local((yyvsp[(1) - (6)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHA, (yyvsp[(1) - (6)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHA, (yyvsp[(1) - (6)].stp)->stval.array) ;
             if ( (yyvsp[(6) - (6)].ival) == '+' )  code1(_POST_INC) ;
             else  code1(_POST_DEC) ;

             (yyval.start) = (yyvsp[(2) - (6)].start) ;
           }
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 735 "parse.y"
    { 
               (yyval.start) = (yyvsp[(3) - (7)].start) ;
               if ( (yyvsp[(5) - (7)].ival) > 1 ) { mawk_code2op(MAWK, A_CAT, (yyvsp[(5) - (7)].ival)) ; }
               check_array(MAWK, (yyvsp[(2) - (7)].stp)) ;
               mawk_code_array(MAWK, (yyvsp[(2) - (7)].stp)) ;
               code1(A_DEL) ;
             }
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 743 "parse.y"
    {
		(yyval.start) = mawk_code_offset ;
		check_array(MAWK, (yyvsp[(2) - (3)].stp)) ;
		mawk_code_array(MAWK, (yyvsp[(2) - (3)].stp)) ;
		code1(DEL_A) ;
	     }
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 754 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ; mawk_BC_new(MAWK) ;
                      (yyval.start) = mawk_code_offset ;

                      check_var(MAWK, (yyvsp[(3) - (6)].stp)) ;
                      mawk_code_address((yyvsp[(3) - (6)].stp)) ;
                      check_array(MAWK, (yyvsp[(5) - (6)].stp)) ;
                      mawk_code_array(MAWK, (yyvsp[(5) - (6)].stp)) ;

                      code2(MAWK, SET_ALOOP, (INST*)0) ;
                    }
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 768 "parse.y"
    { 
		INST *p2 = CDP((yyvsp[(2) - (2)].start)) ;

	        p2[-1].op = mawk_code_ptr - p2 + 1 ;
                mawk_BC_clear(MAWK, mawk_code_ptr+2 , mawk_code_ptr) ;
		mawk_code_jmp(MAWK, ALOOP, p2) ;
		code1(POP_AL) ;
              }
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 785 "parse.y"
    { (yyval.start) = mawk_code_offset ; code2(MAWK, F_PUSHA, (yyvsp[(1) - (1)].cp)) ; }
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 787 "parse.y"
    { check_var(MAWK, (yyvsp[(2) - (2)].stp)) ;
             (yyval.start) = mawk_code_offset ;
             if ( is_local((yyvsp[(2) - (2)].stp)) )
             { mawk_code2op(MAWK, L_PUSHI, (yyvsp[(2) - (2)].stp)->offset) ; }
             else code2(MAWK, _PUSHI, (yyvsp[(2) - (2)].stp)->stval.cp) ;

	     CODE_FE_PUSHA() ;
           }
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 796 "parse.y"
    { 
             if ( (yyvsp[(5) - (6)].ival) > 1 )
             { mawk_code2op(MAWK, A_CAT, (yyvsp[(5) - (6)].ival)) ; }

             check_array(MAWK, (yyvsp[(2) - (6)].stp)) ;
             if( is_local((yyvsp[(2) - (6)].stp)) )
             { mawk_code2op(MAWK, LAE_PUSHI, (yyvsp[(2) - (6)].stp)->offset) ; }
             else code2(MAWK, AE_PUSHI, (yyvsp[(2) - (6)].stp)->stval.array) ;

	     CODE_FE_PUSHA()  ;

             (yyval.start) = (yyvsp[(3) - (6)].start) ;
           }
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 810 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ;  CODE_FE_PUSHA() ; }
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 812 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 816 "parse.y"
    { field_A2I(MAWK) ; }
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 819 "parse.y"
    { code1(F_ASSIGN) ; }
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 820 "parse.y"
    { code1(F_ADD_ASG) ; }
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 821 "parse.y"
    { code1(F_SUB_ASG) ; }
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 822 "parse.y"
    { code1(F_MUL_ASG) ; }
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 823 "parse.y"
    { code1(F_DIV_ASG) ; }
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 824 "parse.y"
    { code1(F_MOD_ASG) ; }
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 825 "parse.y"
    { code1(F_POW_ASG) ; }
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 832 "parse.y"
    { code2(MAWK, _BUILTIN, mawk_bi_split) ; }
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 836 "parse.y"
    { (yyval.start) = (yyvsp[(3) - (5)].start) ;
              check_array(MAWK, (yyvsp[(5) - (5)].stp)) ;
              mawk_code_array(MAWK, (yyvsp[(5) - (5)].stp))  ;
            }
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 843 "parse.y"
    { code2(MAWK, _PUSHI, &MAWK->fs_shadow) ; }
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 845 "parse.y"
    { 
                  if ( CDP((yyvsp[(2) - (3)].start)) == mawk_code_ptr - 2 )
                  {
                    if ( mawk_code_ptr[-2].op == _MATCH0 )
                        RE_as_arg(MAWK) ;
                    else
                    if ( mawk_code_ptr[-2].op == _PUSHS )
                    { CELL *cp = ZMALLOC(CELL) ;

                      cp->type = C_STRING ;
                      cp->ptr = mawk_code_ptr[-1].ptr ;
                      mawk_cast_for_split(MAWK, cp) ;
                      mawk_code_ptr[-2].op = _PUSHC ;
                      mawk_code_ptr[-1].ptr = (PTR) cp ;
                    }
                  }
                }
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 869 "parse.y"
    { (yyval.start) = (yyvsp[(3) - (6)].start) ; 
          code2(MAWK, _BUILTIN, mawk_bi_match) ;
        }
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 876 "parse.y"
    {
	       INST *p1 = CDP((yyvsp[(1) - (1)].start)) ;

               if ( p1 == mawk_code_ptr - 2 ) 
               {
                 if ( p1->op == _MATCH0 ) RE_as_arg(MAWK) ;
                 else
                 if ( p1->op == _PUSHS )
                 { CELL *cp = ZMALLOC(CELL) ;

                   cp->type = C_STRING ;
                   cp->ptr = p1[1].ptr ;
                   mawk_cast_to_RE(MAWK, cp) ;
                   p1->op = _PUSHC ;
                   p1[1].ptr = (PTR) cp ;
                 } 
               }
             }
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 899 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                      code1(_EXIT0) ; }
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 902 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; code1(_EXIT) ; }
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 905 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                      code1(_RET0) ; }
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 908 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; code1(_RET) ; }
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 913 "parse.y"
    { (yyval.start) = mawk_code_offset ;
            code2(MAWK, F_PUSHA, &MAWK->field[0]) ;
            code1(_PUSHINT) ; code1(0) ; 
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
            MAWK->getline_flag = 0 ;
          }
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 920 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (2)].start) ;
            code1(_PUSHINT) ; code1(0) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
            MAWK->getline_flag = 0 ;
          }
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 926 "parse.y"
    { code1(_PUSHINT) ; code1(F_IN) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
            /* getline_flag already off in yylex() */
          }
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 931 "parse.y"
    { code2(MAWK, F_PUSHA, &MAWK->field[0]) ;
            code1(_PUSHINT) ; code1(PIPE_IN) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
          }
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 936 "parse.y"
    { 
            code1(_PUSHINT) ; code1(PIPE_IN) ;
            code2(MAWK, _BUILTIN, mawk_bi_getline) ;
          }
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 942 "parse.y"
    { MAWK->getline_flag = 1 ; }
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 947 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                   code2(MAWK, F_PUSHA, MAWK->field+0) ;
                 }
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 951 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 959 "parse.y"
    {
	     INST *p5 = CDP((yyvsp[(5) - (6)].start)) ;
	     INST *p6 = CDP((yyvsp[(6) - (6)].start)) ;

             if ( p6 - p5 == 2 && p5->op == _PUSHS  )
             { /* cast from STRING to REPL at compile time */
               CELL *cp = ZMALLOC(CELL) ;
               cp->type = C_STRING ;
               cp->ptr = p5[1].ptr ;
               mawk_cast_to_REPL(MAWK, cp) ;
               p5->op = _PUSHC ;
               p5[1].ptr = (PTR) cp ;
             }
             code2(MAWK, _BUILTIN, (yyvsp[(1) - (6)].fp)) ;
             (yyval.start) = (yyvsp[(3) - (6)].start) ;
           }
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 977 "parse.y"
    { (yyval.fp) = mawk_bi_sub ; }
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 978 "parse.y"
    { (yyval.fp) = mawk_bi_gsub ; }
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 983 "parse.y"
    { (yyval.start) = mawk_code_offset ;
                  code2(MAWK, F_PUSHA, &MAWK->field[0]) ; 
                }
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 988 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ; }
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 996 "parse.y"
    { 
		   resize_fblock(MAWK, (yyvsp[(1) - (2)].fbp)) ;
                   mawk_restore_ids(MAWK) ;
		   switch_code_to_main(MAWK) ;
                 }
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1004 "parse.y"
    { mawk_eat_nl(MAWK, &yylval) ;
                   MAWK->scope = SCOPE_FUNCT ;
                   MAWK->active_funct = (yyvsp[(1) - (4)].fbp) ;
                   *MAWK->main_code_p = MAWK->active_code ;

		   (yyvsp[(1) - (4)].fbp)->nargs = (yyvsp[(3) - (4)].ival) ;
                   if ( (yyvsp[(3) - (4)].ival) )
                        (yyvsp[(1) - (4)].fbp)->typev = (char *)
			memset( zmalloc(MAWK, (yyvsp[(3) - (4)].ival)), ST_LOCAL_NONE, (yyvsp[(3) - (4)].ival)) ;
                   else (yyvsp[(1) - (4)].fbp)->typev = (char *) 0 ;

		   mawk_code_ptr = mawk_code_base =
                       (INST *) zmalloc(MAWK, INST_BYTES(PAGESZ));
		   mawk_code_limit = mawk_code_base + PAGESZ ;
		   mawk_code_warn = mawk_code_limit - CODEWARN ;
                 }
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1023 "parse.y"
    { FBLOCK  *fbp ;

                   if ( (yyvsp[(2) - (2)].stp)->type == ST_NONE )
                   {
                         (yyvsp[(2) - (2)].stp)->type = ST_FUNCT ;
                         fbp = (yyvsp[(2) - (2)].stp)->stval.fbp = 
                             (FBLOCK *) zmalloc(MAWK, sizeof(FBLOCK)) ;
                         fbp->name = (yyvsp[(2) - (2)].stp)->name ;
			 fbp->code = (INST*) 0 ;
                   }
                   else
                   {
                         mawk_type_error(MAWK, (yyvsp[(2) - (2)].stp) ) ;

                         /* this FBLOCK will not be put in
                            the symbol table */
                         fbp = (FBLOCK*) zmalloc(MAWK, sizeof(FBLOCK)) ;
                         fbp->name = "" ;
                   }
                   (yyval.fbp) = fbp ;
                 }
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1046 "parse.y"
    { (yyval.fbp) = (yyvsp[(2) - (2)].fbp) ; 
                   if ( (yyvsp[(2) - (2)].fbp)->code ) 
                       mawk_compile_error(MAWK, "redefinition of %s" , (yyvsp[(2) - (2)].fbp)->name) ;
                 }
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1052 "parse.y"
    { (yyval.ival) = 0 ; }
    break;

  case 163:

/* Line 1455 of yacc.c  */
#line 1057 "parse.y"
    { (yyvsp[(1) - (1)].stp) = mawk_save_id(MAWK, (yyvsp[(1) - (1)].stp)->name) ;
                (yyvsp[(1) - (1)].stp)->type = ST_LOCAL_NONE ;
                (yyvsp[(1) - (1)].stp)->offset = 0 ;
                (yyval.ival) = 1 ;
              }
    break;

  case 164:

/* Line 1455 of yacc.c  */
#line 1063 "parse.y"
    { if ( is_local((yyvsp[(3) - (3)].stp)) ) 
                  mawk_compile_error(MAWK, "%s is duplicated in argument list",
                    (yyvsp[(3) - (3)].stp)->name) ;
                else
                { (yyvsp[(3) - (3)].stp) = mawk_save_id(MAWK, (yyvsp[(3) - (3)].stp)->name) ;
                  (yyvsp[(3) - (3)].stp)->type = ST_LOCAL_NONE ;
                  (yyvsp[(3) - (3)].stp)->offset = (yyvsp[(1) - (3)].ival) ;
                  (yyval.ival) = (yyvsp[(1) - (3)].ival) + 1 ;
                }
              }
    break;

  case 165:

/* Line 1455 of yacc.c  */
#line 1076 "parse.y"
    {  /* we may have to recover from a bungled function
		       definition */
		   /* can have local ids, before code scope
		      changes  */
		    mawk_restore_ids(MAWK) ;

		    switch_code_to_main(MAWK) ;
		 }
    break;

  case 166:

/* Line 1455 of yacc.c  */
#line 1088 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ;
             code2(MAWK, _CALL, (yyvsp[(1) - (3)].fbp)) ;

             if ( (yyvsp[(3) - (3)].ca_p) )  code1((yyvsp[(3) - (3)].ca_p)->arg_num+1) ;
             else  code1(0) ;
               
	     mawk_check_fcall(MAWK, (yyvsp[(1) - (3)].fbp), MAWK->scope, MAWK->ps.code_move_level, MAWK->active_funct, 
			 (yyvsp[(3) - (3)].ca_p), MAWK->token_lineno) ;
           }
    break;

  case 167:

/* Line 1455 of yacc.c  */
#line 1100 "parse.y"
    { (yyval.start) = (yyvsp[(2) - (3)].start) ;
             code2(MAWK, _CALL, (yyvsp[(1) - (3)].ptr)) ;

             if ( (yyvsp[(3) - (3)].ca_p) )  code1((yyvsp[(3) - (3)].ca_p)->arg_num+1) ;
             else  code1(0) ;
           }
    break;

  case 168:

/* Line 1455 of yacc.c  */
#line 1109 "parse.y"
    { (yyval.ca_p) = (CA_REC *) 0 ; }
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1111 "parse.y"
    { (yyval.ca_p) = (yyvsp[(2) - (2)].ca_p) ;
                 (yyval.ca_p)->link = (yyvsp[(1) - (2)].ca_p) ;
                 (yyval.ca_p)->arg_num = (yyvsp[(1) - (2)].ca_p) ? (yyvsp[(1) - (2)].ca_p)->arg_num+1 : 0 ;
               }
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1126 "parse.y"
    { (yyval.ca_p) = (CA_REC *) 0 ; }
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1128 "parse.y"
    { (yyval.ca_p) = ZMALLOC(CA_REC) ;
                (yyval.ca_p)->link = (yyvsp[(1) - (3)].ca_p) ;
                (yyval.ca_p)->type = CA_EXPR  ;
                (yyval.ca_p)->arg_num = (yyvsp[(1) - (3)].ca_p) ? (yyvsp[(1) - (3)].ca_p)->arg_num+1 : 0 ;
		(yyval.ca_p)->call_offset = mawk_code_offset ;
              }
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1135 "parse.y"
    { (yyval.ca_p) = ZMALLOC(CA_REC) ;
                (yyval.ca_p)->link = (yyvsp[(1) - (3)].ca_p) ;
                (yyval.ca_p)->arg_num = (yyvsp[(1) - (3)].ca_p) ? (yyvsp[(1) - (3)].ca_p)->arg_num+1 : 0 ;

                mawk_code_call_id(MAWK, (yyval.ca_p), (yyvsp[(2) - (3)].stp)) ;
              }
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1144 "parse.y"
    { (yyval.ca_p) = ZMALLOC(CA_REC) ;
                (yyval.ca_p)->type = CA_EXPR ;
		(yyval.ca_p)->call_offset = mawk_code_offset ;
              }
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1150 "parse.y"
    { (yyval.ca_p) = ZMALLOC(CA_REC) ;
                mawk_code_call_id(MAWK, (yyval.ca_p), (yyvsp[(1) - (2)].stp)) ;
              }
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1157 "parse.y"
    { mawk_parser_include(MAWK, (yyvsp[(2) - (3)].ptr)); }
    break;



/* Line 1455 of yacc.c  */
#line 3548 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (MAWK, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (MAWK, yymsg);
	  }
	else
	  {
	    yyerror (MAWK, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, MAWK);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, MAWK);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (MAWK, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, MAWK);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, MAWK);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 1160 "parse.y"


/* resize the code for a user function */

static void  resize_fblock(mawk_state_t *MAWK, FBLOCK *fbp)
{
  CODEBLOCK *p = ZMALLOC(CODEBLOCK) ;
  unsigned dummy ;

  mawk_code2op(MAWK, _RET0, _HALT) ;
	/* make sure there is always a return */

  *p = MAWK->active_code ;
  fbp->code = mawk_code_shrink(MAWK, p, &dummy) ;
      /* mawk_code_shrink() zfrees p */

  if ( MAWK->dump_code_flag ) mawk_add_to_fdump_list(MAWK, fbp) ;
}


/* convert FE_PUSHA  to  FE_PUSHI
   or F_PUSH to F_PUSHI
*/
static void  field_A2I(mawk_state_t *MAWK)
{
	CELL *cp;

  if ( mawk_code_ptr[-1].op == FE_PUSHA &&
       mawk_code_ptr[-1].ptr == (PTR) 0)
  /* On most architectures, the two mawk_tests are the same; a good
     compiler might eliminate one.  On LM_DOS, and possibly other
     segmented architectures, they are not */
  { mawk_code_ptr[-1].op = FE_PUSHI ; }
  else
  {
    cp = (CELL *) mawk_code_ptr[-1].ptr ;

    if (cp == MAWK->field  || (cp > NF && cp <= LAST_PFIELD))
    {
         mawk_code_ptr[-2].op = _PUSHI  ;
    }
    else if ( cp == NF )
    { mawk_code_ptr[-2].op = NF_PUSHI ; mawk_code_ptr-- ; }

    else
    { 
      mawk_code_ptr[-2].op = F_PUSHI ;
      mawk_code_ptr -> op = mawk_field_addr_to_index(MAWK, mawk_code_ptr[-1].ptr ) ;
      mawk_code_ptr++ ;
    }
  }
}

/* we've seen an ID in a context where it should be a VAR,
   check that's consistent with previous usage */
static void check_var(mawk_state_t *MAWK, register SYMTAB *p)
{
      switch(p->type)
      {
        case ST_NONE : /* new id */
            p->type = ST_VAR ;
            p->stval.cp = ZMALLOC(CELL) ;
            p->stval.cp->type = C_NOINIT ;
            break ;

        case ST_LOCAL_NONE :
            p->type = ST_LOCAL_VAR ;
            MAWK->active_funct->typev[p->offset] = ST_LOCAL_VAR ;
            break ;

        case ST_VAR :
        case ST_LOCAL_VAR :  break ;

        default :
            mawk_type_error(MAWK, p) ;
            break ;
      }
}

/* we've seen an ID in a context where it should be an ARRAY,
   check that's consistent with previous usage */
static  void  check_array(mawk_state_t *MAWK, register SYMTAB *p)
{
      switch(p->type)
      {
        case ST_NONE :  /* a new array */
            p->type = ST_ARRAY ;
            p->stval.array = new_ARRAY() ;
            break ;

        case  ST_ARRAY :
        case  ST_LOCAL_ARRAY :
            break ;

        case  ST_LOCAL_NONE  :
            p->type = ST_LOCAL_ARRAY ;
            MAWK->active_funct->typev[p->offset] = ST_LOCAL_ARRAY ;
            break ;

        default : mawk_type_error(MAWK, p) ; break ;
      }
}

static void mawk_code_array(mawk_state_t *MAWK, register SYMTAB *p)
{
  if ( is_local(p) ) mawk_code2op(MAWK, LA_PUSHA, p->offset) ; 
  else  code2(MAWK, A_PUSHA, p->stval.array) ;
}


/* we've seen an ID as an argument to a user defined function */
static void mawk_code_call_id(mawk_state_t *MAWK, register CA_REC *p, register SYMTAB *ip)
{
  p->call_offset = mawk_code_offset ;
     /* This always get set now.  So that fcall:relocate_arglist
	works. */

  switch( ip->type )
  {
    case  ST_VAR  :
            p->type = CA_EXPR ;
            code2(MAWK, _PUSHI, ip->stval.cp) ;
            break ;

    case  ST_LOCAL_VAR  :
            p->type = CA_EXPR ;
            mawk_code2op(MAWK, L_PUSHI, ip->offset) ;
            break ;

    case  ST_ARRAY  :
            p->type = CA_ARRAY ;
            code2(MAWK, A_PUSHA, ip->stval.array) ;
            break ;

    case  ST_LOCAL_ARRAY :
            p->type = CA_ARRAY ;
            mawk_code2op(MAWK, LA_PUSHA, ip->offset) ;
            break ;

    /* not enough info to code it now; it will have to
       be patched later */

    case  ST_NONE :
            p->type = ST_NONE ;
            p->sym_p = ip ;
            code2(MAWK, _PUSHI, &MAWK->code_call_id_dummy) ;
            break ;

    case  ST_LOCAL_NONE :
            p->type = ST_LOCAL_NONE ;
            p->type_p = & MAWK->active_funct->typev[ip->offset] ;
            mawk_code2op(MAWK, L_PUSHI, ip->offset) ;
            break ;

#ifdef   DEBUG
    default :
            mawk_bozo(MAWK, "mawk_code_call_id") ;
#endif

  }
}

/* an RE by itself was coded as _MATCH0 , change to
   push as an expression */

static void RE_as_arg(mawk_state_t *MAWK)
{
	CELL *cp = ZMALLOC(CELL) ;

  mawk_code_ptr -= 2 ;
  cp->type = C_RE ;
  cp->ptr = mawk_code_ptr[1].ptr ;
  code2(MAWK, _PUSHC, cp) ;
}

/* reset the active_code back to the MAIN block */
static void switch_code_to_main(mawk_state_t *MAWK)
{
   switch(MAWK->scope)
   {
     case SCOPE_BEGIN :
	*MAWK->begin_code_p = MAWK->active_code ;
	MAWK->active_code = *MAWK->main_code_p ;
	break ;

     case SCOPE_END :
	*MAWK->end_code_p = MAWK->active_code ;
	MAWK->active_code = *MAWK->main_code_p ;
	break ;

     case SCOPE_FUNCT :
	MAWK->active_code = *MAWK->main_code_p ;
	break ;

     case SCOPE_MAIN :
	break ;
   }
   MAWK->active_funct = (FBLOCK*) 0 ;
   MAWK->scope = SCOPE_MAIN ;
}


void mawk_parse(mawk_state_t *MAWK)
{
	if (!MAWK->binary_loaded) {
   if ( yyparse(MAWK) || MAWK->compile_error_count != 0 ) mawk_exit(MAWK, 2) ;

   mawk_scan_cleanup(MAWK) ;
   mawk_set_code(MAWK) ;
   /* code must be set before call to mawk_resolve_fcalls() */
   if ( MAWK->resolve_list )  mawk_resolve_fcalls(MAWK) ;
	}

   if ( MAWK->compile_error_count != 0 ) mawk_exit(MAWK, 2) ;
   if ( MAWK->dump_code_flag ) { mawk_dump_code(MAWK) ; mawk_exit(MAWK, 0) ; }
}


void mawk_parser_include(mawk_state_t *MAWK, void *str)
{
	mawk_parser_push(MAWK);

	MAWK->ps.eof_flag = 0 ;
	MAWK->ps.pfile_name = ((STRING *)str)->str;
	MAWK->ps.buffp = MAWK->ps.buffer = (unsigned char *) zmalloc(MAWK, BUFFSZ + 1) ;
	*MAWK->ps.buffp = '\0';
	if (mawk_scan_open(MAWK) == 1)
		MAWK->token_lineno = MAWK->lineno = 1 ;
	else
		mawk_parser_pop(MAWK);
}

