/* number type */
typedef double mawk_num_t;

/* constant format differ for floating point and int */
#define NUM_ZERO 0.0
#define NUM_ONE  1.0
#define NUM_INF HUGE
#define NUM_NAN -HUGE

/* default printf format */
#define NUM_FMT "%g"

/* format for the disassembler */
#define NUM_FMT_DA "%.6g"

#define mawk_num_pow pow
#define mawk_num_sqrt sqrt
#define mawk_num_int(d) ((d) >= NUM_ZERO ? floor(d) : ceil(d))


/* ??? */
#ifdef	 NOINFO_SIGFPE
static char dz_msg[] = "division by zero";
#define	 CHECK_DIVZERO(x) if( (x) == 0.0 )mawk_rt_error(dz_msg);else
#endif
